	freeslot("SKINCOLOR_ADVENTNEONHUD1")
	skincolors[SKINCOLOR_ADVENTNEONHUD1] = {
		name = "adventneonhudcolorthing",
		ramp = {0,0,0,0,0,0,0,0,0,143,0,127,0,174,0,139},
		accessible = false
	}
	freeslot("SKINCOLOR_ADVENTNEONHUD2")
	skincolors[SKINCOLOR_ADVENTNEONHUD2] = {
		name = "adventneonhudcolorthing2",
		ramp = {0,0,0,0,0,0,0,0,0,113,0,125,0,143,0,139},
		accessible = false
	}
	freeslot("SKINCOLOR_ADVENTNEONHUD3")
	skincolors[SKINCOLOR_ADVENTNEONHUD3] = {
		name = "adventneonhudcolorthing3",
		ramp = {0,0,0,0,0,0,0,0,0,96,0,113,0,125,0,143},
		accessible = false
	}
	freeslot("SKINCOLOR_ADVENTNEONHUD4")
	skincolors[SKINCOLOR_ADVENTNEONHUD4] = {
		name = "adventneonhudcolorthing4",
		ramp = {0,0,0,0,0,0,0,0,0,83,0,96,0,113,0,117},
		accessible = false
	}
local function neonhud(v, player)
		local rings = player.rings
		local score = player.score
		local time = player.realtime
		local hourslocation = 130
		local minuteslocation = 155
		local secondslocation = 197
		local centisecondslocation = 220
		local hudringdist = 45
		local flags = V_SNAPTOLEFT|V_SNAPTOTOP|V_PERPLAYER
		local colormap = SKINCOLOR_ADVENTNEONHUD1
		if (hud.enabled("score") or hud.enabled("rings") or hud.enabled("time") or hud.enabled("lives") and not player.hypermysticsonic)
		hud.disable("score")
		hud.disable("rings")
		hud.disable("time")
		hud.disable("lives")
		end
		if (player.hypermysticsonic) 
		hud.enable("score")
		hud.enable("rings")
		hud.enable("time")
		hud.enable("lives")
		return end
		if (rings >= 10 and rings < 100)
		hudringdist = 28
		elseif (rings >= 100 and rings < 1000)
		hudringdist = 25
		elseif (rings >= 1000)
		hudringdist = 20
		elseif (rings < 10)
		hudringdist = 32
		end
		if (G_TicsToHours(player.realtime) >= 10)
		hourslocation = 120
		else
		hourslocation = 130
		end
		if (G_TicsToMinutes(player.realtime) >= 10)
		minuteslocation = 155
		else
		minuteslocation = 162
		end
		if (G_TicsToSeconds(player.realtime) >= 10)
		secondslocation = 194
		else
		secondslocation = 197
		end
		if (G_TicsToSeconds(player.realtime) >= 10)
		centisecondslocation = 230
		else
		centisecondslocation = 220
		end
		if not (player.charflags & SF_SUPER or player.solchar)
		v.draw(8, 60, v.cachePatch("ANHUDRING"), flags)
		elseif (player.charflags & SF_SUPER) 
		v.draw(5, 60, v.cachePatch("ANHUDEMERALD"), flags)
		elseif (player.solchar ~= nil or player.solchar.istransformed)
		v.draw(10, 60, v.cachePatch("ANHUDSOL"), flags)
		end
		if (rings == 0)
		colormap = SKINCOLOR_ADVENTNEONHUD1
		elseif (rings >= 1 and rings < 4)
		colormap = SKINCOLOR_ADVENTNEONHUD2
		elseif (rings >= 4 and rings < 10)
		colormap = SKINCOLOR_ADVENTNEONHUD3
		elseif (rings >= 10)
		colormap = SKINCOLOR_ADVENTNEONHUD4
		end
		v.drawScaled(18*FRACUNIT, 9*FRACUNIT, FRACUNIT/2, v.cachePatch("ANHUDBASE"), flags, v.getColormap("sonic",colormap))
		v.drawNameTag(hourslocation, 13, G_TicsToHours(player.realtime), flags, SKINCOLOR_ORANGE, SKINCOLOR_BLACK)
		v.drawNameTag(minuteslocation, 13, G_TicsToMinutes(player.realtime), flags, SKINCOLOR_ORANGE, SKINCOLOR_BLACK)
		v.drawNameTag(secondslocation, 13, G_TicsToSeconds(player.realtime), flags, SKINCOLOR_ORANGE, SKINCOLOR_BLACK)
		v.drawString(centisecondslocation, 25, ""+G_TicsToCentiseconds(player.realtime)+"", flags|V_GRAYMAP)
		v.drawString(152, 23, ":", flags|V_ORANGEMAP)
		v.drawString(188, 23, ":", flags|V_ORANGEMAP)
		v.drawString(70, 23, "SCORE", flags|V_ORANGEMAP, "small")
		v.draw(15, 50, v.getSprite2Patch(player.mo.skin, "XTRA", false, C, 0), flags, v.getColormap("sonic", player.mo.color))
		v.drawString(55, 28, ""+player.score+"", flags|V_ORANGEMAP, "small") 
		v.drawString(42, 38, ""+skins[player.mo.skin].hudname+"", flags|V_SKYMAP, "small") 
		v.drawString(70, 40, "X"+player.lives+"", flags|V_SKYMAP, "small") 
		v.drawScaledNameTag(hudringdist * FRACUNIT, 18*FRACUNIT, ""+player.rings+"", flags, FRACUNIT/2,SKINCOLOR_PURPLE, SKINCOLOR_BLACK)
	end
	hud.add(neonhud, "game")
	